<template lang="pug">
.row.x-materials-setup-info
  .col-12.py-3.justify-content-center.d-flex(v-if='!loading && $butils.isNil(setup)' key='noSuch')
    span.alert.alert-secondary Unknown Materials Setup
  .col-12(v-if='setup' key='setup')
    BaseCard
      template(v-slot:header='')
        BaseAnimationBlock
          .justify-content-center.d-flex(v-if='loading' key='loading')
            h1 #[i.align-bottom.fa.fa-spinner.fa-pulse]
          .d-flex.justify-content-between.align-items-center(v-else key='title')
            h5 Material Setup #[span.text-muted {{ "#" + setup.id }}]
            router-link.text-dark.text-muted.clickable.ml-1(:to='getRoute("/materials/setups")')
              .fa.fa-caret-up
            .ml-auto.clickable(@click='setEdit(true)' v-if='canEdit && !inEdit')
              kbd.keyHint.mr-2(v-if="showKeyHints") E
              i.fa.fa-cog
            .ml-auto.clickable(@click='setEdit(false)' v-if='canEdit && inEdit')
              kbd.keyHint.mr-2(v-if="showKeyHints") Esc
              i.fa.fa-times
      li(v-if='!setupLoading && !inEdit' key='info')
        mixin info(name)
          .row&attributes(attributes)
            .col-12.text-left.col-sm-3.col-lg-2
              strong= name
            .col-12.text-right.col-sm-9.col-lg-10.text-sm-left
              block
        +info('Id') {{ setup.id }}
        +info('Name') {{ setup.name }}
        +info('Experimental Area') EAR{{ setup.earNumber }}
        +info('Operation Year') {{ setup.operYear }}
      li(v-if='!setupLoading && inEdit' key='edit')
        .row.b-param-container
          BaseParamInput.col-12.col-sm-9(ref='name' title='Name' :inEdit='true' :value='setup.name')
          BaseParamList.col-12.col-sm-3(v-if='isAdmin' ref='earNumber' :inEdit='true' title='Experimental Area' :value='setup.earNumber|toString')
            template(v-slot:options='')
              option(value='1') EAR1
              option(value='2') EAR2
              option(value='3') EAR3
          BaseParamReadonly.col-12.col-sm-3(v-else :inEdit='true' title='Experimental Area' :value='"EAR"+setup.earNumber')
          OperYearSelector.col-12.col-sm-6.col-lg-4(v-if='isAdmin' ref='operYear' :inEdit='true' :value='setup.operYear')
          BaseParamReadonly.col-12.col-sm-6.col-lg-4(v-else :inEdit='true' title='Operation Year' :value='setup.operYear')
      li.px-0.pt-0.x-desc.x-desc(v-if='!setupLoading' key='desc')
        BaseMarkdownWidget(ref='description' :inEdit='inEdit' :value='setup.description')
      li.x-runs(key='runs')
        DBCollapsible(title='Runs' source='runs' parentType='materialsSetups'
                      :parentItem='setup' :query='{ sort: "runNumber:desc" }')
          template(v-slot:row='row')
            router-link.text-primary.text-truncate(:key='row.id' :to='getRoute("/runs/" + row.runNumber)')
              | \#{{row.runNumber}} - {{ row.title }}
      li.p-0.x-materials(key='materials')
        MaterialsSetupMaterials(ref='materials' :materialsSetupId='id' :inEdit='inEdit')
      li(v-if='!loading && inEdit' key='submit')
        .d-flex.justify-content-end
          button.btn.btn-outline-primary.mx-1.x-copy(v-if='isAdmin' @click="doCopy()" title='Copy this Materials Setup')
            i.fa.fa-copy
          button.btn.btn-danger.mx-1.x-delete(v-if='isAdmin' @click="doDelete()" title='Delete Materials Setup')
            i.fa.fa-trash
          router-link.btn.btn-outline-danger.ml-1.x-admin(v-if='!isAdmin && $store.getters.canAdmin' :to='"/admin" + $route.fullPath' title='admin')
            i.fa.fa-key
          button.btn.btn-primary.mx-1.x-submit(@click="doSubmit()")
            kbd.keyHint.mr-2(v-if="showKeyHints") Ctrl+S
            i.fa.fa-upload.mr-1(v-else)
            | Submit
        BaseDialog(v-if='isAdmin' ref='deleteDialog' title='Delete Materials Setup')
          template(v-if='!$butils.isEmpty(runs)')
            p This materials setup is used in some runs.
            p.mb-0 It must be removed from all runs.
          template(v-else)
            p This will permanently delete the materials setup.
            p.mb-0 do you confirm this action ?
          template(v-slot:footer='d')
            button.btn.btn-primary(v-if='!$butils.isEmpty(runs)'
              @click='d.resolve(false)') Cancel
            template(v-else)
              button.mr-1.btn.btn-secondary(@click='d.resolve(false)') Cancel
              button.btn.btn-danger(@click='d.resolve(true)') Ok
        BaseDialog(v-if='isAdmin' ref='titleDialog' title='Material Setup Name')
          p Would you like to update the Material Setup name ?
          BaseParamInput(ref='titleDialogEdit' :title='`Title (current: ${editTitle})`' :inEdit='true')
          template(v-slot:footer='d')
            button.mr-1.btn.btn-danger(@click='d.reject("aborted")') Abort
            button.mr-1.btn.btn-secondary(@click='d.resolve(false)') No
            button.btn.btn-primary(@click='d.resolve(true)') Yes
</template>
<script>
export { default } from './MaterialsSetupInfo.vue.js';
</script>
<style lang='scss'>
.x-materials-setup-info {
  .b-markdown-preview {
    padding-top: .75rem;
    padding-left: 15px;
    padding-right: 15px;
  }
  .x-desc {
    // preview ribbon must be over other elts
    z-index: 1;
  }
}
</style>
